# Run this Jython script inside jHepWork editor
# Java should be installed 

from jhplot import *
from jhplot.io import *
from java.awt import Color
import sys
sys.path.append('modules')

from classes import Point, Peak
from functions_jhplot import FakeGaussian,GetData, FindPeaks, MakeGraph

c1 = HPlot("Canvas",800,500)
c1.setLegend(0) 
c1.setGTitle("PYTHIA8 predictions")
c1.setNameX("M(jet-jet) [GeV]")
c1.setNameY("Events")
c1.visible()
c1.setRange(50,3000,1,50000000)
c1.setLogScale(1,1)

f1 = FileRoot("AllPythiaJetJet.root")
print "number of objects=",f1.getNKeys()
print "ROOT version=",f1.getVersion()

psfig="jjmass.eps"
h1=f1.getH1D("jjmass")
h1.setErrX(0)
h1.setErrY(1)


FakeGaussian(h1, 1000, 20, 200000)
FakeGaussian(h1, 1500, 50, 30000)
FakeGaussian(h1, 2800, 40, 1200)


c1.draw(h1)



data = GetData(h1)
# 7-sigma approach 
minSig=5
peaks = FindPeaks(data, 1, minSig) #returns a list of Peak objects (each peak contains a list of Point objects)

print 'RESULTS OF PEAK SEARCH:\n'
for i in range(len(peaks)):
    print 'Peak Number:', peaks[i].GetPeakNumber(), 'Peak Start:', peaks[i].GetPeakStart().x, 'Peak End:', peaks[i].GetPeakEnd().x, 'Peak Stat Sig:', peaks[i].GetStatSig(), 'Residuals:', peaks[i].GetResiduals(), '\n'
    print peaks[i].GetPeakStart().GetYErrLow(), peaks[i].GetPeakEnd().GetYErrLow() 
print 'END OF PEAK SEARCH RESULTS'

peak,lreg = MakeGraph(peaks)


# always ignore the first point
for i in range(1,len(peak)):


  if (peaks[i].GetStatSig() <minSig): continue

  print 'Peak Number:', peaks[i].GetPeakNumber(), 'Peak Start:', peaks[i].GetPeakStart().x, 'Peak End:', peaks[i].GetPeakEnd().x, 'Peak Stat Sig:', peaks[i].GetStatSig(), 'Residuals:', peaks[i].GetResiduals(), '\n'
  print peaks[i].GetPeakStart().GetYErrLow(), peaks[i].GetPeakEnd().GetYErrLow()


  peakG=peak[i]
  peakG.setColor(Color.blue)
  peakG.setSymbol(8)
  c1.draw(peakG)
  
  lreG=lreg[i]
  lreG.setColor(Color.red)
  lreG.setDrawLine(1)
  lreG.setSymbolSize(0) 
  c1.draw(lreG)
   
  x = peaks[i].GetPeakEnd().GetX()
  y = peaks[i].GetPeakEnd().GetY()
  ssig = '#sigma = ' + str(round(peaks[i].GetStatSig(), 1))
  lab=HLabel(ssig,x+100,y+100, "USER")
  print ssig,x,y
  # lab=HLabel(ssig,0.4,0.5,"NDC")
  c1.add(lab)
  c1.update()


# lab=HLabel(ssig,1000,100000, "USER")
# c1.add(lab)
# c1.update()

# lab=HLabel("KKK",0.4,0.5,"NDC")
# c1.add(lab)
# c1.update()


"""
 l = TLatex()
 l.SetTextAngle(45)
 l.SetTextSize(0.04)
 x = peaks[i].GetPeakEnd().GetX()
 y = peaks[i].GetPeakEnd().GetY()
 ssig = '#sigma = ' + str(round(peaks[i].GetStatSig(), 1))
 l.DrawLatex(x + 100, y + 100, ssig)
"""











c1.export(psfig)



